c ############################################################
c                     Beam Convolution Code
c  This program applies beam convolution to simulated output.
c  See "README-main" and comments provided in the source codes
c  for specific instructions.
c ------------------------------------------------------------
      Program BEAM_SIM
      Implicit NONE
C
C - Common variables are declared and their dimensions are defined.
C
      Include 'BMCVparameters.inc'
c
      Integer ifile
c
c - Sensor parameters and running options are defined.
c
      Call param_set_BMCV ( microw, radar, visIR, crosst_x,
     &                      fov_ct_microw, fov_dt_microw,
     &                      fov_ct_radar, fov_dt_radar, wavel,
     &                      fov_ct_visir, fov_dt_visir, tbform )
c
c - The list of input files is provided.
c
      Call def_file_list ( CRM_file_list )
c
c - Beam convolution is performed consecutively for each model input.
c
      Do 1 ifile = 1 , nmodel
c
      Write(*,*) 'Now processing on '//CRM_file_list(ifile)
c
c ###########################################################
c                --- Microwave Radiometer ---
c    The following subroutine is found in "convolv-fov.f".
c ###########################################################
c
      If ( microw ) then
c
      Call convolv_microw ( CRM_file_list(ifile), crosst_x,
     &                      fov_ct_microw, fov_dt_microw )
c
      Endif
c ###########################################################
c                         --- Radar ---
c    The following subroutine is found in "convolv-fov.f".
c ###########################################################
c
      If ( radar ) then
c
      Call convolv_radar ( CRM_file_list(ifile), crosst_x,
     &                     fov_ct_radar, fov_dt_radar )
c
      Endif

c ###########################################################
c                   --- Vis/IR Radiometer ---
c    The following subroutine is found in "convolv-fov.f".
c ###########################################################
c
      If ( visIR ) then
c
      Call convolv_visIR ( CRM_file_list(ifile), crosst_x, tbform,
     &                     wavel, fov_ct_visir, fov_dt_visir )
c
      Endif
c
 1    Continue
c
      Stop
      End

