************************************************************************
      SUBROUTINE MIE_CSPHERE (X, Y, CREF1, CREF2, 
     +                        QSCAT, QEXTI, ASYM, QBSCAT)
**
**  may become unstable for larger size parameters! Then, the
**  denominators
**  of ANCAP, BNCAP, DNBAR, GNBAR are very small.
**
      IMPLICIT NONE
**
      SAVE
      INTEGER LIMITX
      PARAMETER (LIMITX = 1500)
      
**
      REAL*8 CONV, PI, GHZTOHZ
**
      REAL*8 X, Y
      REAL*8 QSCAT, QEXTI, ASYM, QBSCAT, QEXTI_0
**
      REAL*8 PSIY (-1:LIMITX), CHIY (-1:LIMITX)
**
      REAL*8 RFAC, RFAC1, RFAC2, RFACY
      REAL*8 RHELP1 (2), RHELP2 (2), R100
**
      COMPLEX*16 CREF1, CREF2, CREF, X1, X2, Y1, Y2, CBSCAT
      COMPLEX*16 CHELP1, CHELP2, CFAC1, CFAC2, CFACX2, CFACY2
      COMPLEX*16 ANCAP, BNCAP, DNBAR, GNBAR
      COMPLEX*16 D_ANCAP , D_BNCAP , D_DNBAR , D_GNBAR
      COMPLEX*16 PSIX2, PSIY2, CHIPX2, CHIPY2
**
      COMPLEX*16 DX1 ( 0:LIMITX), DX2   ( 0:LIMITX), DY2   ( 0:LIMITX)
      COMPLEX*16 XIY (-1:LIMITX), CHIX2 (-1:LIMITX), CHIY2 (-1:LIMITX)
      COMPLEX*16 AN     (LIMITX), BN       (LIMITX)
**
      INTEGER I100, I101

      real*8 testpsix2
      real*8 testancap
      real*8 testbncap
      real*8 testpsiy2
      real*8 testden
**
      EQUIVALENCE (CHELP1, RHELP1 (1))
      EQUIVALENCE (CHELP2, RHELP2 (1))
**
      COMMON / ENVIRO1 / CONV, PI, GHZTOHZ     
**
      X1   = CREF1 * X
      X2   = CREF2 * X
      Y1   = CREF1 * Y
      Y2   = CREF2 * Y
      CREF = CREF2 / CREF1
**
      DX1 (0) = CDCOS (X1) / CDSIN (X1)
      DX2 (0) = CDCOS (X2) / CDSIN (X2)
      DY2 (0) = CDCOS (Y2) / CDSIN (Y2)
**
      PSIY (-1) =          COS (Y)
      PSIY ( 0) =          SIN (Y)
      CHIY (-1) = -1.0D0 * SIN (Y)
      CHIY ( 0) =          COS (Y)
      XIY  (-1) = CMPLX (PSIY (-1),-CHIY (-1))
      XIY  ( 0) = CMPLX (PSIY ( 0),-CHIY ( 0))
**
      CHIY2 (-1) = -1.0D0 * CDSIN (Y2)
      CHIY2 ( 0) =          CDCOS (Y2)
      CHIX2 (-1) = -1.0D0 * CDSIN (X2)
      CHIX2 ( 0) =          CDCOS (X2)
**
      QEXTI   = 0.0D0
      QEXTI_0 = 0.0D0
      QSCAT   = 0.0D0
      ASYM    = 0.0D0
      CBSCAT  = CMPLX (0.0D0,0.0D0)      
**
      DO 100 I100 = 1, LIMITX
         R100   = I100 * 1.0D0
         RFAC   = 2.0D0 * R100 - 1.0D0
         RFACY  = RFAC / Y
         CFACX2 = RFAC / X2
         CFACY2 = RFAC / Y2
**
         PSIY (I100) = RFACY * PSIY (I100 - 1) - PSIY (I100 - 2)
         CHIY (I100) = RFACY * CHIY (I100 - 1) - CHIY (I100 - 2)
         XIY  (I100) = CMPLX (PSIY (I100),-CHIY (I100))
**
         DY2 (I100) = 1.0D0 / (R100 / Y2 - DY2 (I100 - 1)) - R100 / Y2
         DX1 (I100) = 1.0D0 / (R100 / X1 - DX1 (I100 - 1)) - R100 / X1
         DX2 (I100) = 1.0D0 / (R100 / X2 - DX2 (I100 - 1)) - R100 / X2
**
         CHIX2 (I100) = CFACX2 * CHIX2 (I100 - 1) - CHIX2 (I100 - 2)
         CHIY2 (I100) = CFACY2 * CHIY2 (I100 - 1) - CHIY2 (I100 - 2)
         CHIPX2 = CHIX2 (I100 - 1) - R100 * CHIX2 (I100) / X2
         CHIPY2 = CHIY2 (I100 - 1) - R100 * CHIY2 (I100) / Y2
**
         PSIX2 = 1.0D0 / (CHIX2 (I100) * DX2 (I100) - CHIPX2)  
         PSIY2 = 1.0D0 / (CHIY2 (I100) * DY2 (I100) - CHIPY2)
**
	 D_ANCAP = CREF * DX1 (I100) * CHIX2 (I100) - CHIPX2
         D_BNCAP = CREF * CHIPX2 - CHIX2 (I100) * DX1 (I100)
**
         ANCAP = PSIX2 * (CREF * DX1 (I100) - DX2 (I100)) /
     +    D_ANCAP        
         BNCAP = PSIX2 * (CREF * DX2 (I100) - DX1 (I100)) / 
     +    D_BNCAP
**
c      modification of original P. Bauer code:
         testpsix2=CDABS(chix2(i100)*dx2(i100)-chipx2)
         testpsiy2=CDABS(chiy2(i100)*dy2(i100)-chipy2)
         testancap=CDABS(cref*dx1(i100)*chix2(i100)-chipx2)
         testbncap=CDABS(cref*chipx2-chix2(i100)*dx1(i100))
         if(testpsix2 .gt. 1.D-15 .and.
     +      testancap .gt. 1.D-15 .and.
     +      testpsiy2 .gt. 1.D-15) then
           DNBAR = (DY2 (I100) - ANCAP * CHIPY2 / PSIY2)
     +           / (1.0D0 -  ANCAP * CHIY2 (I100) / PSIY2)
         else if((testpsix2 .le. 1.D-15 .or.
     +            testancap .le. 1.D-15) .and.
     +            testpsiy2 .gt. 1.D-15) then
           DNBAR = CHIPY2/CHIY2(i100)
         else if((testpsix2 .gt. 1.D-15 .and.
     +           testancap .gt. 1.D-15) .and.
     +           testpsiy2 .le. 1.D-15) then
           DNBAR = DY2 (I100)
         else
           DNBAR = (DY2 (I100) - CHIPY2)
     +           / (1.0D0 -  CHIY2 (I100))
         end if

         if(testpsix2 .gt. 1.D-15 .and.
     +      testbncap .gt. 1.D-15 .and.
     +      testpsiy2 .gt. 1.D-15) then
            testden=CDABS(1.0-BNCAP*CHIY2(I100)/PSIY2)
           if(testden .gt. 1.D-15) then
             GNBAR = (DY2 (I100) - BNCAP * CHIPY2 / PSIY2)
     +           / (1.0D0 -  BNCAP * CHIY2 (I100) / PSIY2)
           else
             GNBAR=GNBAR
           end if
         else if((testpsix2 .le. 1.D-15 .or.
     +            testbncap .le. 1.D-15) .and.
     +            testpsiy2 .gt. 1.D-15) then
           GNBAR = CHIPY2/CHIY2(i100)
         else if((testpsix2 .gt. 1.D-15 .and.
     +           testbncap .gt. 1.D-15) .and.
     +           testpsiy2 .le. 1.D-15) then
           GNBAR = DY2 (I100)
         else
           GNBAR = (DY2 (I100) - CHIPY2)
     +           / (1.0D0 -  CHIY2 (I100))
         end if
**
         CFAC1 = (DNBAR / CREF2 + R100 / Y) 
     +         * PSIY (I100) - PSIY (I100 - 1)
         CFAC2 = (DNBAR / CREF2 + R100 / Y) 
     +         * XIY  (I100) - XIY  (I100 - 1)
         AN (I100) = CFAC1 / CFAC2 
**      
         CFAC1 = (GNBAR * CREF2 + R100 / Y) 
     +         * PSIY (I100) - PSIY (I100 - 1)
         CFAC2 = (GNBAR * CREF2 + R100 / Y) 
     +         * XIY  (I100) - XIY  (I100 - 1)
         BN (I100) = CFAC1 / CFAC2   
**
         QSCAT = QSCAT + (2.0D0 * R100 + 1.0) 
     +         * (CDABS (AN (I100)) * CDABS (AN (I100)) 
     +          + CDABS (BN (I100)) * CDABS (BN (I100)))
         QEXTI = QEXTI + (2.0D0 * R100 + 1.0) 
     +         * (DBLE (AN (I100)) + DBlE (BN (I100)))
         CBSCAT = CBSCAT + (2.0D0 * I100 + 1.0) * (-1.0) ** I100
     +          * (AN (I100) - BN (I100))     
**
         IF (I100 .EQ. 1) GO TO 100
**
         CHELP1 = AN (I100 - 1) * CONJG (AN (I100))
     +          + BN (I100 - 1) * CONJG (BN (I100))
         CHELP2 = AN (I100 - 1) * CONJG (BN (I100 - 1))
**
         I101 = I100 - 1
         RFAC1  = I101 * (I101 + 2) / (I101 + 1.0)
         RFAC2  = (2.0D0 * I101 + 1.0) / (I101 * (I101 + 1.0))
**
         ASYM = ASYM + RFAC1 * RHELP1 (1) + RFAC2 * RHELP2 (1)
**
c     smaller tolerance (0.001 as opposed to 0.01)
         IF (ABS (QEXTI - QEXTI_0) / QEXTI .LT. 0.001) GO TO 9999
**
	 QEXTI_0  = QEXTI
100   CONTINUE
9999  CONTINUE
**
      QEXTI = QEXTI * 2.0D0 / (Y * Y)
      QSCAT = QSCAT * 2.0D0 / (Y * Y)
      ASYM  = ASYM  * 4.0D0 / (Y * Y * QSCAT)
      QBSCAT = CDABS (CBSCAT) * CDABS (CBSCAT) / (Y * Y)    
**
      RETURN
      END
**
************************************************************************
