      Subroutine open_lut_rdr(
     $                    kextci_lut_nf,salbci_lut_nf,pbckci_lut_nf,
     &                    kextcw_lut_nf,salbcw_lut_nf,pbckcw_lut_nf,
     &                    kextrr_lut_nf,salbrr_lut_nf,pbckrr_lut_nf,
     &                    kextsn_lut_nf,salbsn_lut_nf,pbcksn_lut_nf,
     &                    kextgr_lut_nf,salbgr_lut_nf,pbckgr_lut_nf,
     &                    kexthl_lut_nf,salbhl_lut_nf,pbckhl_lut_nf,
     &                    kextml_lut_nf,salbml_lut_nf,pbckml_lut_nf,
     &                    pts_temp_w, pts_temp_i, pts_hydro,
     &                    npts_temp, npts_hydro )
      Implicit NONE
c
c This subroutine reads the Mie lookup tables created by the
c program stored in "src/MieLUT". Any changes made to the LUT
c format must be reflected in this subroutine (and its MW radiometer
c counterpart, "src/simulator/microw/open-lut-mwr.f"). Make sure
c that the specified file names match existing LUTs. The path
c to LUTs is given by "lutdir" defined in "../MAINparameters.inc".
c
      Include '../MAINparameters.inc'
c
      Integer nf
      real *4 kextrr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbrr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 pbckrr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextci_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbci_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 pbckci_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextcw_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 salbcw_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 pbckcw_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextsn_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 salbsn_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 pbcksn_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextgr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbgr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 pbckgr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kexthl_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbhl_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 pbckhl_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextml_lut_nf(mxpts_hydro, mxfreq) 
      real *4 salbml_lut_nf(mxpts_hydro, mxfreq)
      real *4 pbckml_lut_nf(mxpts_hydro, mxfreq)
      Real *4 frequency
      Integer i,j
      Integer npts_temp,npts_hydro
      Character*3 nch(mxfreq_radar)
      Character fname_in*13

c #####################################################################
c "nch(*)" should be specified so it matches the labels of lookup tables.
c #####################################################################
      nch(1) = '14G'
c
      Do 100 nf = 1 , mxfreq_radar
c
      Do 10 i = 1, mxpts_temp
         Do 10 j = 1, mxpts_hydro
            kextci_lut_nf(i,j,nf) = 0.
            salbci_lut_nf(i,j,nf) = 0.
            pbckci_lut_nf(i,j,nf) = 0.
            kextcw_lut_nf(i,j,nf) = 0.
            salbcw_lut_nf(i,j,nf) = 0.
            pbckcw_lut_nf(i,j,nf) = 0.
            kexthl_lut_nf(i,j,nf) = 0.
            salbhl_lut_nf(i,j,nf) = 0.
            pbckhl_lut_nf(i,j,nf) = 0.
            kextsn_lut_nf(i,j,nf) = 0.
            salbsn_lut_nf(i,j,nf) = 0.
            pbcksn_lut_nf(i,j,nf) = 0.
            kextgr_lut_nf(i,j,nf) = 0.
            salbgr_lut_nf(i,j,nf) = 0.
            pbckgr_lut_nf(i,j,nf) = 0.
            kextrr_lut_nf(i,j,nf) = 0.
            salbrr_lut_nf(i,j,nf) = 0.
            pbckrr_lut_nf(i,j,nf) = 0.
 10   Continue
      Do 13 j = 1, mxpts_hydro
            kextml_lut_nf(j,nf) = 0.
            salbml_lut_nf(j,nf) = 0.
            pbckml_lut_nf(j,nf) = 0.
 13   Continue
c
c Cloud Ice
c
      fname_in = 'CI-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextci_lut_nf(i,j,nf),salbci_lut_nf(i,j,nf),
     &                                   pbckci_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Cloud Water
c
      fname_in = 'CW-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_w(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextcw_lut_nf(i,j,nf),salbcw_lut_nf(i,j,nf),
     &                                   pbckcw_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Rain
c
      fname_in = 'RR-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_w(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextrr_lut_nf(i,j,nf),salbrr_lut_nf(i,j,nf),
     &                                   pbckrr_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Snow
c
      fname_in = 'SN-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextsn_lut_nf(i,j,nf),salbsn_lut_nf(i,j,nf),
     &                                   pbcksn_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Graupel
c
      fname_in = 'GR-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextgr_lut_nf(i,j,nf),salbgr_lut_nf(i,j,nf),
     &                                   pbckgr_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Hail
c
      fname_in = 'HL-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kexthl_lut_nf(i,j,nf),salbhl_lut_nf(i,j,nf),
     &                                   pbckhl_lut_nf(i,j,nf),
     &                       j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Melting particles
c
      fname_in = 'ML-rdr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_hydro
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) (kextml_lut_nf(j,nf),salbml_lut_nf(j,nf),
     &                                 pbckml_lut_nf(j,nf),
     &                                   j = 1,npts_hydro)
c
      close (50)
c
 100   Continue
c
      Return
      End

