      SUBROUTINE AXB(C,A,B,NI,NK,NJ,NCI,NAI,NBI)
C  C = A*B
C--- HISTORY
C 88. 6. 6   REGISTERED BY T. NAKAJIMA
C--- INPUT
C A      R(NAI,*)     2-DIM ARRAY  A.
C B      R(NBI,*)     2-DIM ARRAY  B.
C NI, NK, NJ  I       C(I,J) = A(I,K)*B(K,J)
C                     I=1,NI; K=1,NK; J=1,NJ
C NCI      I          SIZE FOR C(NCI,*)
C NAI      I          SIZE FOR A(NAI,*)
C NBI      I          SIZE FOR B(NBI,*)
C--- OUTPUT
C C      R(NCI,*)     A*B.
C$ENDI
      DIMENSION A(NAI,*),B(NBI,*),C(NCI,*)
      DO 1 I=1,NI
      DO 1 J=1,NJ
      S=0.0
      DO 2 K=1,NK
    2 S=S+A(I,K)*B(K,J)
    1 C(I,J)=S
      RETURN
      END
      SUBROUTINE AAPB(A,B,NI,NJ,NAI,NBI)
C A=A+B
C--- HISTORY
C 88. 6. 6  REGISTERED BY T.NAKAJIMA
C--- INPUT
C A    R(NAI,*)    2-DIM ARRAY  A.
C B    R(NBI,*)    2-DIM ARRAY  B.
C NI      I        SUM (I,J) I=1,NI
C NJ      I        SUM (I,J) J=1,NI
C--- OUTPUT
C A                A+B
C$ENDI
      DIMENSION A(NAI,*),B(NBI,*)
      DO 1 J=1,NJ
      DO 1 I=1,NI
    1 A(I,J)=A(I,J)+B(I,J)
      RETURN
      END
      SUBROUTINE RP33(A,B,NI,NJ,K,L,NA1,NA2,NA3,NB1,NB2,NB3)
C A(*,*,K) = B(*,*,L)
C--- HISTORY
C 88. 5. 6  REGISTERED BY T. NAKAJIMA
C--- INPUT
C B      R(NB1,NB2,NB3)     SOURCE 3-DIM ARRAY  B.
C NI,NJ,K,L    I            A(I,J,K)=B(I,J,L), I=1,NI; J=1,NJ
C NA1,NA2,NA3  I            DIM A(NA1,NA2,NA3)
C NB1,NB2,NB3  I            DIM B(NB1,NB2,NB3)
C--- OUTPUT
C A      R(NA1,NA2,NA3)     DESTINATION 3-DIM ARRAY A(*,*,K)=B(*,*,L)
C$ENDI
      DIMENSION A(NA1,NA2,NA3),B(NB1,NB2,NB3)
      DO 1 J=1,NJ
      DO 1 I=1,NI
    1 A(I,J,K)=B(I,J,L)
      RETURN
      END
      SUBROUTINE RP30(A,B,NI,NJ,K,NA1,NA2,NA3)
C A(*,*,K) = B
C--- HISTORY
C 88. 5. 6   REGISTERED BY T. NAKAJIMA
C--- INPUT
C B            R       SOURCE SCALER
C NI,NJ,K      I       A(I,J,K)=B,  I=1,NI; J=1,NJ
C NA1,NA2,NA3  I       DIM A(NA1,NA2,NA3)
C--- OUTPUT
C A    R(NA1,NA2,NA3)  DESTINATION 3-DIM ARRAY A(*,*,K)=B
C$ENDI
      DIMENSION A(NA1,NA2,NA3)
      DO 1 J=1,NJ
      DO 1 I=1,NI
    1 A(I,J,K)=B
      RETURN
      END
      SUBROUTINE APB(C,A,B,NI,NJ,NCI,NAI,NBI)
C C=A+B
C--- HISTORY
C 88. 6. 6  REGISTERED BY T. NAKAJIMA
C--- INPUT
C  A       R(NAI,*)     2-DIM ARRAY A.
C  B       R(NBI,*)     2-DIM ARRAY B.
C NI         I          SUM (I,J) , I=1,NI
C NJ         I          SUM (I,J) , J=1,NJ
C NCI        I          SIZE FOR C(NCI,*)
C NAI        I          SIZE FOR A(NAI,*)
C NBI        I          SIZE FOR B(NBI,*)
C--- OUTPUT
C  C       R(NCI,*)     A+B
C$ENDI
      DIMENSION A(NAI,*),B(NBI,*),C(NCI,*)
      DO 1 J=1,NJ
      DO 1 I=1,NI
    1 C(I,J)=A(I,J)+B(I,J)
      RETURN
      END
