      FUNCTION BPLNK(W,T)
C PLANK FUNCTION WITH RESPECT TO WAVELENGTH
C--- HISTORY
C 89. 8. 1  CREATED
C--- INPUT
C W      R      WAVELENGTH (MICRON)
C T      R      ABSOLUTE TEMPERATURE (K)
C--- OUTPUT
C BPLNK  RF     PLANK FUNCTION (W/M2/STR/MICRON)
      IF(W*T.LE.0.0) THEN
        BPLNK=0
       ELSE
        X=1.438786E4/W/T
        BPLNK=1.1911E8/W**5/(EXPFN(X)-1)
      ENDIF
      RETURN
      END
      FUNCTION TBB(WL,BB)
C CALCULAION Brightness temperature
C--- History
C 1994.1.11 CCS
C--- Input
C WL     R     Wavelength in micron
C BB     R     Radiance (Watt/m2/str/micron)
C--- Output
C TBB    R     Brightness temperature (K)
C
      TBB=1.438786E4/WL/LOG(1.1911E8/WL**5/BB+1)
      RETURN
      END
