      FUNCTION EXX(EX,T1,T2,X)
C EXP(EX)*INTEG(FROM T1 TO T2) DT EXP(XT)
C--- HISTORY
C 89.11. 3 MODIFIED
      SAVE EPS,EXMN,INIT
      DIMENSION CCP(3)
      DATA INIT/1/
      IF(INIT.EQ.1) THEN
        INIT=0
        CALL CPCON(CCP)
        EPS=CCP(1)*100
        EXMN=CCP(2)*0.8*2.3
      ENDIF
      EX1=EX+X*T1
      EX2=EXPFN(EX1)
      T22=T2-T1
      IF(ABS(T22*X).LE.EPS) THEN
         EXX=EX2*(T22+X*T22**2/2.0)
        ELSE
         EX3=EX+X*T2
         IF(EX3.LE.EXMN) THEN
           EXX=-EX2/X
          ELSE
           EXX=(EXP(EX3)-EX2)/X
         ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE EXINT(AM1U,AM0,DPT,T1,T2,C)
C INTEGRAL(FROM T1 TO T2) DT EXP(-(THK-T)/AM1U-T/AM0)
C--- HISTORY
C 90. 1.13 CREATED
C--- INPUT
C AM1U     R      USERDEFINED EMERGENT MU.
C                 IF .GT. 0 THEN DOWN,  IF .LT. 0 THEN UPWARD.
C AM0      R      SOLAR DIRECTION.
C DPT      R      OPTICAL DEPTH FOR INTERPOLATION.
C T1       R      LOWER LIMIT OF INTEGRATION.
C T2       R      UPPER LIMIT OF INTEGRATION.
C--- OUTPUT
C C        R      INTEGRATION.
      EX=-DPT/AM1U
      X=1/AM1U-1/AM0
      C=EXX(EX,T1,T2,X)
      RETURN
      END
      SUBROUTINE CSINT(AM1U,ZE,THK,DPT,T1,T2,C,SL,SL1)
C INTEGRAL(FROM T1 TO T2) DT EXP(-(DPT-T)/AM1U) C(T, THK)
C   WHERE C(T, THK) = (EXP(-Z*(THK-T)+EXP(-Z*T))/2
C WE ALSO DEFINE THE INTEGRAL FOR THE FUNCTIONS: S*Z, S/Z.
C--- HISTORY
C 90. 1.13 CREATED
C--- INPUT
C AM1U     R      USERDEFINED EMERGENT MU.
C                 IF .GT. 0 THEN DOWN,  IF .LT. 0 THEN UPWARD.
C ZE       R      EIGENVALUE (L).
C THK      R      OPTICAL THICKNESS OF LAYER.
C DPT      R      OPTICAL DEPTH FOR INTERPOLATION.
C T1       R      LOWER LIMIT OF INTEGRATION.
C T2       R      UPPER LIMIT OF INTEGRATION.
C--- OUTPUT
C C        R      INTEGRATION OF C.
C SL       R      INTEGRATION OF S*L.
C SL1      R      INTEGRATION OF S/L.
      SAVE EPS,INIT
      DIMENSION CCP(3)
      DATA INIT/1/
      IF(INIT.EQ.1) THEN
        INIT=0
        CALL CPCON(CCP)
        EPS=CCP(1)*100
      ENDIF
C C
      EX=-DPT/AM1U-ZE*THK
      X=1/AM1U+ZE
      EX1=EXX(EX,T1,T2,X)
      EX=-DPT/AM1U
      X=1/AM1U-ZE
      EX2=EXX(EX,T1,T2,X)
      C =(EX1+EX2)/2
      IF(ABS(ZE*T1).GT.EPS .OR. ABS(ZE*T2).GT.EPS) THEN
        SL1=(EX1-EX2)/2.0/ZE
       ELSE
        EX=(T1-DPT)/AM1U
        EX1=EXPFN(EX)
        EX=(T2-DPT)/AM1U
        EX2=EXPFN(EX)
        EX=-DPT/AM1U
        X=1/AM1U
        EX3=EXX(EX,T1,T2,X)
        SL1=AM1U*(T2*EX2-T1*EX1)-(AM1U+THK/2)*EX3
      ENDIF
      SL =ZE**2*SL1
      RETURN
      END
