      FUNCTION EXPFN(X)
C EXPONENTIAL FUNCTION WITH OVER/UNDER FLOW SETTING.
C--- HISTORY
C 89. 5. 4   CREATED BY T. NAKAJIMA.
C 90. 1.17   UPDATED WITH CPCON
C--- INPUT
C X        R         INDEPENDENT VARIABLE.
C--- OUTPUT
C EXPFN    F         EXP(X).
C                     IF X.LE. VMN THEN EXP(X) IS RESET AS   0.
C                     IF X.GE. VMX THEN EXP(X) IS RESET AS EXP(VMX).
C--- PARAMETERS
C SYSTEM SET THE -VMN- AND -VMX- BY THE FUNCTION R1MACH.
C
      SAVE INIT,VMN,VMX,EXPMN,EXPMX
      DIMENSION CCP(3)
      DATA INIT/1/
C
C SET VMN      R         ENDERFLOW LIMIT.
C     VMX      R         OVERFLOW LIMT.
      IF(INIT.GT.0) THEN
        INIT=0
        CALL CPCON(CCP)
        VMN=CCP(2)*0.8*2.3
        VMX=CCP(3)*0.8*2.3
        EXPMN=0
        EXPMX=EXP(VMX)
      ENDIF
C
      IF(X.LE.VMN) THEN
        EXPFN=EXPMN
        ELSE
        IF(X.GE.VMX) THEN
          EXPFN=EXPMX
          ELSE
          EXPFN=EXP(X)
        ENDIF
      ENDIF
      RETURN
      END
