      Subroutine out_visIR ( I_visIR, ngridx, ngridy, nlyr, 
     &                       deltax, deltay, wavel, znth_slr, 
     &                       znth_obs, azmth, filename )
      Implicit NONE
c
c This subroutine writes out visible and IR radiance.
c
c Inputs:
c  - Sensor and model parameters
c     wavel, znth_slr, znth_obs, azmth
c  - Model spatial dimensions
c     ngridx, ngridy, nlyr, deltax, deltay
c  - I/O
c     filename
c  - Simulated result
c     I_visIR
c
c Output:
c  - (NONE)
c
      Include '../MAINparameters.inc'
c
      Integer i,j,nchar,length_char,nw
      character*90 pathandfile
      character*(*) filename
c
      nchar = length_char ( filename )
      nchar = nchar - 8    !! to eliminate '.profile' at the end.
c
c Data dimensions in ascii format
c
      pathandfile = outputdir//filename(1:nchar)//'.vir.info'
      open(unit= 17, file = pathandfile,
     +     status = 'unknown', form = 'formatted')
      write(17,551) ngridx, ngridy, nlyr, deltax, deltay
      write(17,*) 'solar zenith angle:',znth_slr
      write(17,*) 'viewing zenith angle:',znth_obs
      write(17,*) 'viewing-to-solar azimuth angle:',azmth
      write(17,*) mxwavel,' wavelengths at', wavel,' micron'
c
c Computed radiances in binary format
c
      pathandfile = outputdir//filename(1:nchar)//'.vir.bin'
      open(unit= 22, file = pathandfile,
     +     access='direct', recl=ngridx*ngridy*mxwavel*4)
      write(22,rec=1) (((I_visIR(i,j,nw),i=1,ngridx),
     &                    j=1,ngridy),nw=1,mxwavel)
c
      Close (17)
      Close (22)
c
  551 format(i3,' x ',i3,' (x,y) grid; ',i3,' layers; ',
     &       ' deltax = ',f6.2,' km','  deltay = ',f6.2,' km')
c
      Return
      End

