      SUBROUTINE PHAS2(M1,MMAX1,N1,N2,KNP,KN1,KN2,PT,PR,G
     & ,PL1,PL2)
C--- HISTORY
C 90. 1.20  GENERATED FROM PHASE (SAME AS PHASE BUT USING THE MOMENTS G)
C--- INPUT
C M1         I       M + 1    FOURIER ORDER + 1.
C MMAX1      I       MMAX+1   MAX FOURIER ORDER + 1.
C N1         I       NO. OF EMERGENT ZENITH ANGLES.
C N2         I       NO. OF INCIDENT ZENITH ANGLES.
C KNP        I       SIZE OF N1 FOR ARRAY PT AND PR.
C KN1        I       SIZE OF N1 FOR ARRAY PL1.
C KN2        I       SIZE OF N2 FOR ARRAY PL2.
C G     R(MMAX1)     LEGENDRE MOMENTS OF PHASE FUNCTION.
C                      G(1)=1
C PL1   R(KN1,MMAX1) LEGENDRE POLYNOMIALS FOR EMERGENT DIRECTION.
C                    (I,M1) = (EMERGENT DIRECTIONS, ORDER+1).
C PL2   R(KN2,MMAX1) LEGENDRE POLYNOMIALS FOR INCIDENT DIRECTION.
C--- OUTPUT
C PT    R(KNP,N2)    PHASE MATRIX FOR TRANSMISSION.
C PR    R(KNP,N2)    PHASE MATRIX FOR REFLECTION.
C$ENDI
C
      PARAMETER (PI=3.141592653)
      DIMENSION PT(KNP,*),PR(KNP,*),G(*)
     & ,PL1(KN1,*),PL2(KN2,*)
C
      CALL EQ20(PT,0.0,N1,N2,KNP,N2)
      CALL EQ20(PR,0.0,N1,N2,KNP,N2)
      IF(M1.LE.MMAX1) THEN
        DO 1 J=1,N2
        DO 1 I=1,N1
        SIGN=-1
        DO 1 K1=M1,MMAX1
        SIGN=-SIGN
        C4=(2*K1-1)/2.0*G(K1)*PL1(I,K1)*PL2(J,K1)
        PT(I,J)=PT(I,J)+C4
    1   PR(I,J)=PR(I,J)+SIGN*C4
      ENDIF
      RETURN
      END
