      FUNCTION PINT4(INIT,ANG1,KNA,NA,ANG,P,L)
C INTERPOLATION OF THE PHASE FUNCTION.
C--- HISTORY
C 89.11. 8 CREATED FROM PINT3. CHANGE INTERPOLATION X-> ANG
C 90. 1.23 DEBUG
C--- INPUT
C INIT       I      1 THEN SEARCH ANG1-INTERVAL ELSE NOT SEARCH.
C ANG1       R      SCATTERING ANGLE IN DEGREE FOR INTERPOLATION.
C NA         I      NO. OF SCATTERING ANGLES.
C ANG      R(NA)    SCATTERING ANGLES IN DEGREE.
C P     R(KNA,L)    PHASE FUNCTION
C L          I      LAYER NUMBER
C--- OUTPUT VARIABLES
C INIT       I      0
C PINT4      R      INTERPOLATED VALUE OF P AT ANG1.
C$ENDI
C--- VARIABLES FOR THE ROUTINE.
      SAVE I1,I2,I3
      DIMENSION ANG(*),P(KNA,*)
C--- WORKING AREAS.
      PARAMETER (PI=3.141592654, RAD=PI/180.0)
C
      IF(INIT.GE.1) THEN
        INIT=0
        DO 1 I=1,NA-1
        IF((ANG1-ANG(I))*(ANG1-ANG(I+1)).LE.0.0) GOTO 2
    1   CONTINUE
        I=NA
    2   IF(I-1) 3,3,4
    3   I1=1
        I3=3
        GO TO 5
C *
    4   IF(I-NA+1) 6,7,7
    6   I1=I-1
        I3=I+1
        GO TO 5
C *
    7   I1=NA-2
        I3=NA
    5   I2=I1+1
      ENDIF
      XX=ANG1
      X1=ANG(I1)
      X2=ANG(I2)
      X3=ANG(I3)
      ALP1=P(I1,L)
      ALP2=P(I2,L)
      ALP3=P(I3,L)
      ISIGN=-1
      IF(ALP1.GT.0.0 .AND. ALP2.GT.0.0 .AND. ALP3.GT.0.0) THEN
        ISIGN=1
        ALP1=LOG(ALP1)
        ALP2=LOG(ALP2)
        ALP3=LOG(ALP3)
      ENDIF
      PP=(XX-X2)*(XX-X3)/(X1-X2)/(X1-X3)*ALP1
     &  +(XX-X1)*(XX-X3)/(X2-X1)/(X2-X3)*ALP2
     &  +(XX-X1)*(XX-X2)/(X3-X1)/(X3-X2)*ALP3
      IF(ISIGN.GE.1) PP=EXPFN(PP)
      PINT4=PP
      RETURN
      END
