      SUBROUTINE    TNVSS2(N,A,DT,E,NN,IW,ERR)
C     INVERSION OF REAL MATRIX. SWEEP OUT, COMPLETE POSITIONING.
C--- HISTORY
C 71. 4.30 CREATED BY SAKATA MASATO
C 89.11.10 ADDED ERR
C 90. 1. 6 ERR*(*)
C--- INPUT
C N       I        DIMENSION OF THE MATRIX
C A     R(NN,N)    MATRIX
C NN      I        SIZE OF FIRST ARGUMENT
C E       R        CONVERGENCE CRITERION (0 IS OK)
C--- OUTPUT
C DT      R        DETERMINATION OF THE MATRIX
C IW    I(2*N)     WORKING AREA
C ERR    C*64      ERROR INDICATER. IF ' ' then no error.
C$ENDI
      CHARACTER ERR*(*)
      DIMENSION     A(NN,*)  ,IW(*)
      ERR=' '
      IF(N-1)    910,930,101
  101 IF(N.GT.NN)    GO TO  900
      EPS=0.0
      DT=1.0
      DO  100     K=1,N
      PIV=0.0
      DO  110       I=K,N
      DO  110       J=K,N
      IF(ABS(A(I,J)).LE.ABS(PIV))   GO TO  110
      IPIV=I
      JPIV=J
      PIV=A(I,J)
  110 CONTINUE
      DT=DT*PIV
      IF(ABS(PIV).LE.EPS)  GO TO 920
      IF(K.EQ.1)   EPS=ABS(PIV)*E
      IF(IPIV.EQ.K)      GO TO 130
      DT=-DT
      DO 120   J=1,N
      WORK=A(IPIV,J)
      A(IPIV,J)=A(K,J)
  120 A(K,J)=WORK
  130 IF(JPIV.EQ.K)      GO TO  150
      DT=-DT
      DO 140   I=1,N
      WORK=A(I,JPIV)
      A(I,JPIV)=A(I,K)
  140 A(I,K)=WORK
  150 IW(2*K-1)=IPIV
      AA=1.0/PIV
      IW(2*K)=JPIV
      DO 210   J=1,N
  210 A(K,J)=A(K,J)*AA
      DO 220  I=1,N
      IF(I.EQ.K)    GO TO  220
      AZ=A(I,K)
      IF(AZ.EQ.0.0)   GO TO  220
      DO 230   J=1,N
  230 A(I,J)=A(I,J)-A(K,J)*AZ
      A(I,K)=-AA*AZ
  220 CONTINUE
  100 A(K,K)=AA
      DO  400 KK=2,N
      K=N+1-KK
      IJ=IW(2*K)
      IF(IJ.EQ.K)   GO TO  420
      DO 410   J=1,N
      WORK=A(IJ,J)
      A(IJ,J)=A(K,J)
  410 A(K,J)=WORK
  420 IJ=IW(2*K-1)
      IF(IJ.EQ.K)   GO TO  400
      DO 430   I=1,N
      WORK=A(I,IJ)
      A(I,IJ)=A(I,K)
  430 A(I,K)=WORK
  400 CONTINUE
      RETURN
  910 ERR='ERROR IN TINVSS: N.LE.0'
      RETURN
  900 ERR='ERROR IN TINVSS: N.GT.NN'
      RETURN
  920 DT=0.0
      INDER=N-K+1
      NNN=K-1
      WRITE(ERR,1) NNN
    1 FORMAT('TINVSS: ILL CONDITIONED MATRIX WITH RANK ',I5)
      RETURN
  930 DT=A(1,1)
      K=1
      IF(DT.EQ.0.0)     GO TO  920
      A(1,1)=1.0/A(1,1)
      RETURN
      END
